#include <conio.h>
#include <process.h>
#include <sched.h>
#include <string.h>

int main(int argc , char ** argv)
{
	int policy = -1;
	int quantum;
	int id1, id2, id3;    	/* ID of child process */
	int i, j;

	if (argc == 3) {
		if (!strcmp(argv[1], "rr")) {
			policy = 0;
		} else if (!strcmp(argv[1], "mlf")) {
			policy = 1;
		} else if (!strcmp(argv[1], "edf")) {
			policy = 2;
		}
		else {
			Print("usage: %s [rr|mlf|edf] <quantum>\n", argv[0]);
			Exit(1);
		}
		quantum = atoi(argv[2]);
		Set_Scheduling_Policy(policy, quantum);
	} else {
		Print("usage: %s [rr|mlf|edf] <quantum>\n", argv[0]);
		Exit(1);
	}

	Print ("************* Start Workload Generator *********\n");

	//Spawn_Program is syscall : Sys_Spawn 
	id1 = Spawn_Program ("/c/p1.exe", "/c/p1.exe",50);
	Print ("Process p1 has been created with ID = %d\n",id1);

	for (i=0 ; i<10 ; i++)
	{
		for(j=0 ; j<20 ; j++)
			Get_Time_Of_Day();
	}

	id2 = Spawn_Program ("/c/p2.exe", "/c/p2.exe",10);
	Print ("\nProcess P2 has been created with ID = %d\n",id2);

	for (i=0 ; i<10 ; i++)
	{
		for(j=0 ; j<20 ; j++)
			Get_Time_Of_Day();
	}

	id3 = Spawn_Program ("/c/p3.exe", "/c/p3.exe",30);
	Print ("\nProcess P3 has been created with ID = %d\n",id3);

	Wait(id1);
	Wait(id2);
	Wait(id3);

	Print ("Tests Completed\n");

	return 0;
}

